﻿using C1.WPF.RichTextBox;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Xml;

namespace RichTextBoxToolbar
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }
        static string fileName = "ToolBar.xml";
        private void ToolBar_Loaded(object sender, RoutedEventArgs e)
        {
            C1RichTextBoxToolbar toolbar = sender as C1RichTextBoxToolbar;
            C1FontFamilyTool fontFamily = (C1FontFamilyTool)toolbar.Template.FindName("13_T", toolbar);
            C1FontSizeTool fontSize = (C1FontSizeTool)toolbar.Template.FindName("15_T", toolbar);
            try
            {
                using (StreamReader reader = File.OpenText(fileName))
                {
                    ToolbarSetting setting = new ToolbarSetting();
                    System.Xml.Serialization.XmlSerializer xml = new System.Xml.Serialization.XmlSerializer(typeof(ToolbarSetting));
                    setting = (ToolbarSetting)xml.Deserialize(reader);
                    fontSize.SelectedValue = Double.Parse(setting.SavedFontSize);
                    fontFamily.SelectedValue = new FontFamily(setting.SavedFontFamily);
                }
            }
            catch (Exception ex)
            {
                fontSize.SelectedIndex = 0;
                fontFamily.SelectedIndex = 0;
            }
        }

        private void Window_Closing(object sender, System.ComponentModel.CancelEventArgs e)
        {
            if(rtbToolbar.IsLoaded)
            {
                C1FontFamilyTool fontFamily = (C1FontFamilyTool)rtbToolbar.Template.FindName("13_T", rtbToolbar);
                C1FontSizeTool fontSize = (C1FontSizeTool)rtbToolbar.Template.FindName("15_T", rtbToolbar);

                using (XmlWriter writer = XmlWriter.Create(fileName))
                {
                    ToolbarSetting setting = new ToolbarSetting();
                    if(fontSize.SelectedValue!=null & fontFamily.SelectedValue!=null)
                    {
                        setting.SavedFontSize = fontSize.SelectedValue.ToString();
                        setting.SavedFontFamily = fontFamily.SelectedValue.ToString();
                        System.Xml.Serialization.XmlSerializer xml = new System.Xml.Serialization.XmlSerializer(typeof(ToolbarSetting));
                        xml.Serialize(writer, setting);
                    }                    
                }
            }
        }
    }
}
